package sun.nio.fs;

class WindowsSecurity
{
    static final long processTokenWithDuplicateAccess;
    static final long processTokenWithQueryAccess;
    
    private WindowsSecurity() {
    }
    
    private static long openProcessToken(int n) {
        try {
            return WindowsNativeDispatcher.OpenProcessToken(WindowsNativeDispatcher.GetCurrentProcess(), n);
        }
        catch (WindowsException ex) {
            return 0L;
        }
    }
    
    static WindowsSecurity.Privilege enablePrivilege(String s) {
        long lookupPrivilegeValue;
        try {
            lookupPrivilegeValue = WindowsNativeDispatcher.LookupPrivilegeValue(s);
        }
        catch (WindowsException detailMessage) {
            throw new AssertionError(detailMessage);
        }
        long n = 0L;
        int n2 = 0;
        int n3 = 0;
        try {
            n = WindowsNativeDispatcher.OpenThreadToken(WindowsNativeDispatcher.GetCurrentThread(), 32, false);
            if (n == 0L && WindowsSecurity.processTokenWithDuplicateAccess != 0L) {
                n = WindowsNativeDispatcher.DuplicateTokenEx(WindowsSecurity.processTokenWithDuplicateAccess, 36);
                WindowsNativeDispatcher.SetThreadToken(0L, n);
                n2 = 1;
            }
            if (n != 0L) {
                WindowsNativeDispatcher.AdjustTokenPrivileges(n, lookupPrivilegeValue, 2);
                n3 = 1;
            }
        }
        catch (WindowsException ex) {}
        return ()/*  */ -> {
            try {
                if (var_3_13 != 0L) {
                    try {
                        if (var_6_18) {
                            WindowsNativeDispatcher.SetThreadToken(0L, 0L);
                        }
                        else if (var_1_04) {
                            WindowsNativeDispatcher.AdjustTokenPrivileges(var_3_13, n4, 0);
                        }
                    }
                    catch (WindowsException detailMessage2) {
                        throw new AssertionError(detailMessage2);
                    }
                    finally {
                        WindowsNativeDispatcher.CloseHandle(var_3_13);
                    }
                }
            }
            finally {
                WindowsNativeDispatcher.LocalFree(n4);
            }
            return;
        };
    }
    
    static boolean checkAccessMask(long n, int n2, int n3, int n4, int n5, int n6) throws WindowsException {
        int n7 = 8;
        long n8 = WindowsNativeDispatcher.OpenThreadToken(WindowsNativeDispatcher.GetCurrentThread(), n7, false);
        if (n8 == 0L && WindowsSecurity.processTokenWithDuplicateAccess != 0L) {
            n8 = WindowsNativeDispatcher.DuplicateTokenEx(WindowsSecurity.processTokenWithDuplicateAccess, n7);
        }
        boolean accessCheck = false;
        if (n8 != 0L) {
            try {
                accessCheck = WindowsNativeDispatcher.AccessCheck(n8, n, n2, n3, n4, n5, n6);
            }
            finally {
                WindowsNativeDispatcher.CloseHandle(n8);
            }
        }
        return accessCheck;
    }
    
    static {
        processTokenWithDuplicateAccess = openProcessToken(2);
        processTokenWithQueryAccess = openProcessToken(8);
    }
    
    interface Privilege
    {
        public abstract void drop();
    }
}
